
public class LastQuiz {

    public static void main(String[] args) {

        // Q1
        int N = 10;
        int[] arr = new int[N];

        // initialize array to random ints 1..100
        for(int i=0;i<arr.length;i++){
            arr[i] = (int)(Math.random()*100);
            System.out.print(""+arr[i]+", ");
        }
        System.out.println("\n");

        // Q2
        int min,max,sum;
        double avg;

        if(arr.length > 0){
            min = max = sum = arr[0];
            for(int i=1;i<arr.length;i++){
                if(arr[i] > max)
                    max = arr[i];
                if(arr[i] < min)
                    min = arr[i];
                sum += arr[i];
            }
            avg = sum / (double)arr.length;
            System.out.println("sum:"+sum);
            System.out.println("min:"+min);
            System.out.println("max:"+max);
            System.out.println("avg:"+avg);
        }
    
        //Q3 grow array by 50%

        System.out.print("arr before: [");
        for(int i=0;i<arr.length;i++)
            System.out.print(""+arr[i]+", ");
        System.out.println("]");

        int[] t = new int[(int)(arr.length * 1.5)];
        for(int i=0;i<arr.length;i++)
            t[i] = arr[i];
        arr = t;

        System.out.print("arr after:  [");
        for(int i=0;i<arr.length;i++)
            System.out.print(""+arr[i]+", ");
        System.out.println("]");

        // What is a ``Value Object''?
        // value objects are essentially data containers
        // with no functionality besides setter/getter 
        // methods. ie: equivalent to C structures.

        // What is a ``DAO'' object.
        // Data Access Object---a helper class/object
        // that reads/writes Value Objects from/to 
        // some data storage thing (ie: file/db/etc.).
        // You can define different DAOs for 
        // different storage mechanisms of the same
        // value object, ie: you can store 
        // ''Customer'' objects in database AND file.

    }
}
